



#include<simplecpp>
#include <iostream>

using namespace std;
bool SolveSudoku();


 int Sudoku[9][9];

//
// Functions for Validation of Sudoku
//

// The ValidateinputHV function Checks
// whether the row and column of a particular
// box does not contain the same element as that
// of the box.
bool ValidateinputHV(int row, int col){

  for(int a=0; a<9; a++){
    //the for loop checks the element in a column by varying a
    if(Sudoku[row][col]==Sudoku[row][a]&&a!=col){
        //if element found
        return false;
    }
  }

  for(int b=0; b<9; b++){
    if(Sudoku[row][col]==Sudoku[b][col]&&b!=row){
        return false;
    }
  }
  //if the element is unique in the row &column in which it is present
return true;
}


// The ValidateinputBX functions checks
// weather the box of a particular grid
// does not contain the same number as that
// of the grid.
bool ValidateinputBX(int row, int col){

     int p=0;
     int q=0;

for(q=(row/3)*3;q<=((row/3)*3)+2; q++) //this loop makes sure that the q varies only in that 3x3 grid which contains the element
    {
    for(p=(col/3)*3;p<=((col/3)*3)+2; p++)
    {

if(Sudoku[row][col]==Sudoku[q][p]&&(!(p==col&&q==row)))
    {
        return false;
        }

    }

}
return true;
}



//
// FUNCTIONS FOR SOLVING THE SUDOKU
//


// UsedinRow functions sees to it
// if an element is already present
// in the Row or not.
bool UsedinRow(int row, int num)
{
    for (int col = 0; col < 9; col++)
        {
        if (Sudoku[row][col]==num)
            return true;
    }
    return false;
}




// UsedinCol functions sees to it
// if an element is already present
// in the Column or not.
bool UsedinCol(int col, int num)
{
    for (int row = 0; row < 9; row++)
        {
        if (Sudoku[row][col] == num)
            return true;
            }
    return false;
}




// UsedinBox functions sees to it
// if an element is already present
// in the Box or not
bool UsedinBox(int row,int col,int num){

// p and q are 2 variables that vary
// Column and Row wise respectively
// in the box of a particular grid

    int p=0;
    int q=0;

   for(q=(row/3)*3;q<=((row/3)*3)+2; q++)
   {
      for(p=(col/3)*3;p<=((col/3)*3)+2; p++)
      {
         if(Sudoku[q][p]==num)
         {
           return true;
         }
      }
   }
return false;
}



// The Function FindUnassignedLocation
// finds the location of an empty grid by using the method pass by reference
bool FindUnassignedLocation(int &row1, int &col1){


    for ( row1 = 0; row1 < 9; row1++)
    {
        for ( col1 = 0; col1 < 9; col1++)
        {
            if (Sudoku[row1][col1] == 0)//implies empty grid
            {
                return true;
            }
        }
    }

return false;
}

// The NoConflicts Function sees to it
// that the a number which we intend
// to fill in the Empty Grid is a
// valid step in the Solving of Sudoku
bool NoConflicts(int row,int col,int num)
{
        return (!UsedinRow(row,num) &&!UsedinCol(col, num) &&!UsedinBox(row,col,num));
//uses all the three functions defined above

}


bool SolveSudoku()
{
    int row, col;

    // If the Programme finds no unassigned location
    // then the Soduko was already solved.
    // Return True.
    if (!FindUnassignedLocation(row ,col))
       return true;

    // Here the Programme starts filling in
    // the numbers staring from 1 to 9
    // in the empty grid that we found
    for (int num = 1; num <= 9; num++)
    {

      // If the Number we selected
      // is a valid step then we can
      // proceed
      if (NoConflicts( row, col, num))
        {
            // if the step is valid,
            // then we make the tentative assignment
            Sudoku[row][col] = num;

            // If the tentative assignments
            // worked then the Sudoku is completely
            // solved, hence return true.
            if (SolveSudoku())
                return true;

            // if we fail,then we unmake the assignment
            // and then try again
            Sudoku[row][col] = 0;
        }
    }
    return false;
    // this step is the main step involving backtracking

}

//the main function begins here which controls all the necessary working



int main()
{


  //Initiallise the Array sudoku to Zero

    int r = 0;
    int c = 0;

    for(r=0 ; r<9; r++)
    {
      for(c=0; c<9; c++)
      {
        Sudoku[r][c]=0;

      }
    }


// Graphics Part started by building the canvas
initCanvas("sudoku solver", 1000,1000);

//count is the counter which keeps the value of no. of elements
int count=0;

//these are the various coordintes of the different icons that appear on the canvas
float bcx=300;
float bcy=100;
float bsx=800;
float bsy=100;
float bhx=800;
float bhy=200;
float length=100;
float width=50;

float bmx=800;
float bmy=375;
float bex=800;
float bey=500;
float benx=800;
float beny=300;

//this is rectangle for check button and solve button
Rectangle checkbotton(bcx,bcy,length,width),validbutton(bsx,bsy,length,width);
// text inside tthe check and solve button
Text tcheck(bcx,bcy,"CHECK"),tvalid(bsx,bsy,"SOLVE");
//this is the rectangle for help button
Rectangle helpbutton(bhx,bhy,length,width);
// rectangle for message button
Rectangle messagebutt(bmx,bmy,length+50,width);
//rectangle for quit button
Rectangle quitbutt(bex,bey+175,length/2,width/2);

Text quitt(bex,bey+175,"quit");

Text thelp(bhx,bhy,"HELP"),trules(bmx,bmy,"MESSAGE BOX");

// this is the 9x9 double dimensional array of object text and stores all the integers in the grid
Text cj1[9][9];

Text mess1;

Text mess2;

Text mess5;

Text mess4;

Rectangle messbox(bex,bey,length+300,width+250);

//this specifies the dimensions of the grid
float lgrid=50;
float wgrid=50;
float gx=100;
float gy=300;
//this command welcomes the user when the canvas is formed
Text welcome(bex,bey,"WELCOME TO SUDOKU SOLVER");
wait(5);
welcome.reset(0,0,"");

//this is the double dimensional array of objects rectangle which creates the sudoku grid on the canvas
Rectangle grid[9][9];

   for(int i=0;i<9;i++)
   {
      for(int j=0;j<9;j++)
      {
        grid[i][j].reset(gx+i*50,gy+j*50,lgrid,wgrid);//creating the grid
      }
   }



while(1)
{
    count=0;
    //counts the no. of elements in sudoku after every iteration
    for(int b=0;b<9;b++)
    {
      for(int c=0;c<9;c++)
      {
        if(Sudoku[b][c]!=0)
        {
            count++; //counter
         }
      }
    }

      if(count==0){mess4.reset(bex,bey+50,"the sudoku contains no elements");}
      if(count!=0){mess4.reset(0,0,"");}



//there two events defined
//the first event  is for the mouse click
//the second event is the pressing of a key
        XEvent event;
        XEvent event1;
     nextEvent(event);


//checks that the first event is pressing of mouse key
    if(mouseButtonPressEvent(event)){

//checks whether the the mouse is clicked in quit button or not
       if(event.xbutton.x<=bex+25&&event.xbutton.x>=bex-25&&event.xbutton.y<=bey+12.5+175&&event.xbutton.y>=bey+175-12.5)
    {
        {
            mess1.reset(bex,bey,"THANK YOU!!");
            mess2.reset(0,0,"");
            mess4.reset(0,0,"");
            wait(3);
            return 0;
            //returns if the user wants to quit

        }

    }




// checks if the check button is clicked
    if(event.xbutton.x<=bcx+50&&event.xbutton.x>=bcx-50&&event.xbutton.y<=bcy+25&&event.xbutton.y>=bcy-25)
    {

        int row;
        int col;     //necessary initializations
        int k=0;
        int l=0;
        bool resultHV;
        bool resultBX;


     //Horizontal and Vertical Check
     for(row=0; row<9; row++)
        {
        for(col=0; col<9; col++)
        {
           if(Sudoku[row][col]!=0)
           {
             resultHV = ValidateinputHV(row,col);
// keeps track of exactly how many elements are according to the rules of sudoku
           if(resultHV){k++;}
           }
        }
     }

 //prints appropriate error messeages
        if(k==count)
        {
            mess1.reset(bex,bey+25,"the sudoku is valid horizontally & vertically");
        }
        else{
            mess1.reset(bex,bey+25,"the sudoku is not valid horizontally & vertically");
        }

     //Box Check .
     for(row=0; row<9; row++)
        {
        for(col=0; col<9; col++)
        {
           if((row>=0&&row<9&&col>=0&&col<9)&&Sudoku[row][col]!=0)
           {
             resultBX = ValidateinputBX(row,col);

             if(resultBX){l++;}
           }
        }
     }

//appropriate messages
            if(l==count){mess2.reset(bex,bey,"the sudoku is valid boxwise");}
            else {mess2.reset(bex,bey,"the sudoku is not valid boxwise");}




     }
//checks whether the solve button is clicked or not
      if(event.xbutton.x<=bsx+50&&event.xbutton.x>=bsx-50&&event.xbutton.y<=bsy+25&&event.xbutton.y>=bsy-25)
        {


     int row;
     int col;
     int k=0;
     int l=0;
     bool resultHV;
     bool resultBX;


     //Horizontal and Vertical Check
     for(row=0; row<9; row++)
        {
        for(col=0; col<9; col++)
        {
            if(Sudoku[row][col]!=0)
            {
               resultHV = ValidateinputHV(row,col);

            if(resultHV){k++;}
            }
        }
     }



        if(k==count)
        {
              mess1.reset(bex,bey,"the sudoku is valid Horizontally&Vertically ");
        }
        else{   mess1.reset(bex,bey,"the sudoku is invalid ");continue;    }


     //Box Check
     for(row=0; row<9; row++)
        {
        for(col=0; col<9; col++)
        {
           if((row>=0&&row<9&&col>=0&&col<9)&&Sudoku[row][col]!=0)
           {
              resultBX = ValidateinputBX(row,col);

           if(resultBX){l++;}
           }
        }
     }

     if(l==count){mess2.reset(bex,bey+25,"Sudoku is Valid Box-Wise");}

     if(l!=count){

            mess2.reset(bex,bey+25,"but the given sudoku is invalid boxwise hence can't be solved");
          continue;
        }

     if(count<17)
        //the user shoud know that is the if no. elements is lesses than 17 then there can be multiple solution

        {
            mess5.reset(bex,bey+75,"THIS SOLUTION OF THE SUDOKU HOWEVER, IS NOT UNIQUE ");

        }
// calling the SolveSudoku function
//solves the sudoku by using all the function defined above
    bool a = SolveSudoku();



// Print the sudoku
  for(int i=0;i<9;i++)
    {
    for(int j=0; j<9; j++)
    {
     cj1[i][j].reset(100+50*i,300+50*j,Sudoku[i][j]);
    }
  }




      }
//
//help  button clicked
      if(event.xbutton.x<=bhx+50&&event.xbutton.x>=bhx-50&&event.xbutton.y<=bhy+25&&event.xbutton.y>=bhy-25)
        {

          Text sol(bex,bey-50,"the basic rules of sudoku is simple");
          Text sol2(bex,bey-25,"the no. sholud be filled in such a way that");
          Text sol3(bex,bey,"it is the only no. in the row or column or the ");
          Text sol4(bex,bey+25,"respective 3X3 grid in which it is filled. Just check");
          Text sol5(bex,bey+50,"your sudoku your sudoku by clicking check or if you");
          Text sol6(bex,bey+74,"have entered the correct sudoku then solve it. Just hit solve" );
        wait(3);

      }

//coordintes of the position where the mouse is clicked
      int x =  event.xbutton.x;
       int y= event.xbutton.y;

// if the mouse is clicked inside the grid
   if(event.xbutton.x<=550&&event.xbutton.x>=100&&event.xbutton.y<=750&&event.xbutton.y>=300)
    {

//then another event i.e. any keyword in keyboard is pressed


     int i,j;

while(1){

     nextEvent(event1);
     if(keyPressEvent(event1)){

         for( i=0;i<9;i++)
     {

      for( j=0;j<9;j++)
      {



         if(x<=125+i*50&&x>=75+i*50&&y>=275+50*j&&y<=325+50*j)
         {
              char ch=charFromEvent(event1);
           //converts the character into the integer
            int a=ch-'0';
           if(a>=0&&a<10)
           {
           cj1[i][j].reset(100+50*i,300+50*j,a)  ;

          Sudoku[i][j]=a;
}
          else{mess2.reset(bex,bey,"Please enter a number between 0 and 9");}

         }

      }

     }

       break;

     }

     }

    }

    }

}

}






